<script lang="ts">
import Vue from "vue";
import { SlpButton } from "slippers-ui";
import { FreeTrialVariant } from "@/common/constants";

export default Vue.extend({
  name: "NavButton",
  components: { SlpButton },
  props: {
    href: {
      type: String,
      required: true,
    },
    freeTrialVariant: {
      type: String,
      default: "primary",
      validator(value: string) {
        return Object.values(FreeTrialVariant).includes(
          value as FreeTrialVariant
        );
      },
    },
  },
  data() {
    return {
      ctaVariants: FreeTrialVariant,
    };
  },
  mounted() {
    if (this.freeTrialVariant === FreeTrialVariant.STEEL) {
      const navButtonComponent = this.$refs.navButton as InstanceType<
        typeof Vue
      >;
      for (let i = 1; i <= 2; i++) {
        setTimeout(() => {
          navButtonComponent?.$el.classList.add(
            "be-nav__nav-button--animate"
          );
          setTimeout(
            () =>
              navButtonComponent?.$el.classList.remove(
                "be-nav__nav-button--animate"
              ),
            500 * i
          );
        }, 2000 * i);
      }
    }
  },
});
</script>

<template>
  <SlpButton
    ref="navButton"
    variant="primary"
    class="be-nav__nav-button"
    :href="href"
    :class="{
      'be-nav__nav-button--accent': freeTrialVariant === ctaVariants.ACCENT,
      'be-nav__nav-button--gleam': freeTrialVariant === ctaVariants.GLEAM,
      'be-nav__nav-button--steel': freeTrialVariant === ctaVariants.STEEL,
    }"
  >
    <slot></slot>
  </SlpButton>
</template>

<style lang="scss">
.be-nav__nav-button {
  transition: background-color 0.1s ease-in-out !important;

  &--steel {
    background: linear-gradient(
      93.83deg,
      rgba(0, 0, 0, 1) 7.27%,
      rgba(0, 0, 0, 1) 105.33%
    ) !important;
    position: relative;
    overflow: hidden;

    &:after {
      content: "";
      position: absolute;
      top: 0;
      left: -200%;
      width: 200%;
      height: 100%;
      transform: skewX(-20deg);
      background-image: linear-gradient(
        to right,
        transparent,
        rgba(255, 255, 255, 0.5),
        transparent
      );
    }

    &:hover {
      background-color: $color-primary-300 !important;
      color: $color-primary-300 !important;
    }

    &:hover:after {
      animation: shine 0.8s ease-in-out;
    }
  }

  &--accent {
    background-color: $color-accent-300 !important;
    color: $color-primary-300 !important;
    border-color: $color-accent-300 !important;

    &:hover {
      background-color: $color-primary-300 !important;
      color: $color-accent-300 !important;
    }
  }

  &--animate {
    &:after {
      animation: shine 1s ease-in-out;
    }
  }

  &--gleam {
    background: linear-gradient(
      93.83deg,
      rgba(199, 177, 254, 0.75) 7.27%,
      rgba(255, 212, 216, 0.75) 105.33%
    ) !important;
    color: $color-primary-200 !important;
    border: none !important;
    position: relative;
    overflow: hidden;

    &:after {
      content: "";
      position: absolute;
      top: 0;
      left: -200%;
      width: 200%;
      height: 100%;
      transform: skewX(-20deg);
      background-image: linear-gradient(
        to right,
        transparent,
        rgba(255, 255, 255, 0.5),
        transparent
      );
    }

    &:hover:after {
      animation: shine 0.8s ease-in-out;
    }
  }
}

@keyframes shine {
  100% {
    left: 200%;
  }
}
</style>
